'Include file for CheckBook program

'--------------------------------------------------------------------------------
'   ** Constants **
'--------------------------------------------------------------------------------
$catgFile               = "Categories.ini"
%IDD_DIALOG1            = 101
%IDR_MENU1              = 102
%IDM_FILE_OPEN          = 1001
%IDM_FILE_SAVE          = 1002
%IDM_FILE_SAVEAS        = 1003
%IDM_FILE_PRINT         = 1004
%IDM_FILE_CHANGEACCT    = 1005
%IDM_FILE_LASTACCT      = 1006
%IDM_FILE_ARCHIVE       = 1007
%IDM_FILE_EXIT          = 1008
%IDM_EDIT_ADDENTRY      = 1101
%IDM_EDIT_NEWENTRY      = 1102
%IDM_EDIT_CHGENTRY      = 1103
%IDM_EDIT_DUPENTRY      = 1104
%IDM_EDIT_MOVENTRY      = 1105
%IDM_EDIT_DELENTRY      = 1106
%IDM_EDIT_VOIDENTRY     = 1107
%IDM_EDIT_CHGGROUP      = 1108
%IDM_EDIT_FINDENTRY     = 1109
%IDM_EDIT_FINDPAYEE     = 1110
%IDM_EDIT_MOENTRIES     = 1151
%IDM_EDIT_ADDMOENTRY    = 1152
%IDM_EDIT_DELMOENTRY    = 1153
%IDM_VIEW_ENTRY         = 1201
%IDM_VIEW_SELECTONE     = 1202
%IDM_VIEW_SELECTALL     = 1203
%IDM_VIEW_DESELECT      = 1204
%IDM_VIEW_SPLIT         = 1205
%IDM_VIEW_QUIT          = 1206
%IDM_TASKS_ACCTS        = 1301
%IDM_TASKS_STMTS        = 1302
%IDM_TASKS_CATGS        = 1303
%IDM_TASKS_REPORTS      = 1304
%IDM_TASKS_CALENDAR     = 1305
%IDM_TASKS_CALCULATOR   = 1306
%IDM_REC_BEGIN          = 1401
%IDM_REC_CLEARED        = 1402
%IDM_REC_CLOSE          = 1403
%IDM_REC_INIT           = 1404
%IDM_REC_SUMMARY        = 1405
%IDM_HELP_HELP          = 1501
%IDM_HELP_ABOUT         = 1502

%IDC_SCROLLBAR1         = 2101  'register
%IDC_LABEL1             = 2102
%IDC_StatusBar          = 2106
%IDC_Status1            = 2107
%IDC_Status2            = 2108
%IDC_Status3            = 2109
%IDC_Memo               = 2110
%IDC_Catg               = 2111

%IDC_Kbd                = 2201   'addEntry
%IDC_AddDate            = 2202
%IDC_AddCkNo            = 2203
%IDC_AddPayee           = 2204
%IDC_AddPay             = 2205
%IDC_AddDep             = 2206
%IDC_AddMemo            = 2207
%IDC_AddCatg            = 2208
%IDC_AddSubCatg         = 2209
%IDC_EnterBtn           = 2210
%IDC_NewBtn             = 2211
%IDC_ChgBtn             = 2212
%IDC_LABEL2             = 2213
%IDC_LABEL3             = 2214
%IDC_FontSize           = 2215
%IDC_findBtn            = 2216
%IDC_QuitBtn            = 2217
%IDC_ShowStmt           = 2218

%IDC_Accts              = 2300   'selectAcct
%IDC_NewAcct            = 2301
%IDC_EditAcct           = 2302
%IDC_DelAcct            = 2303
%IDC_AcctName           = 2304
%IDC_AcctBal            = 2305
%IDC_AcctDate           = 2306
%IDC_AcctID             = 2307
%IDC_AcctOk             = 2308
%IDC_AcctCancel         = 2309

%IDC_StmtDate           = 2401   'openStmt
%IDC_StmtOpenBal        = 2402
%IDC_StmtCloseBal       = 2403
%IDC_StmtOk             = 2404
%IDC_StmtCancel         = 2405

%IDC_Stmts              = 2501   'stmtList
%IDC_NewStmt            = 2502
%IDC_EditStmt           = 2503
%IDC_DelStmt            = 2504
%IDC_ViewStmt           = 2505

%IDC_ThisAcct           = 2701   'search
%IDC_AllAccts           = 2702
%IDC_Partial            = 2703
%IDC_Exact              = 2704
%IDC_Greater            = 2705
%IDC_Less               = 2706
%IDC_FindOk             = 2707 
%IDC_PayeeLB            = 2708

%IDC_Categories         = 2800   'categories
%IDC_NewCatg            = 2801
%IDC_EditCatg           = 2802
%IDC_DelCatg            = 2803
'%IDC_QuitCatg           = 2804
%IDC_DefCatg            = 2805
%IDC_DefSubcatg         = 2806
%IDC_DefCatgTax         = 2807
%IDC_DefCatgBudget      = 2808
%IDC_DefCatgIncome      = 2809
%IDC_DefCatgOk          = 2810

%IDC_SplitItems         = 3000  'split items
%IDC_AddItem            = 3001
%IDC_EditItem           = 3002
%IDC_DelItem            = 3003
%IDC_SplitOk            = 3004
%IDC_SplitAmt           = 3005
%IDC_SplitCatg          = 3006
%IDC_SplitSubcatg       = 3007
%IDC_SplitDescr         = 3008
%IDC_SplitItemOk        = 3009

%IDC_DelMemos           = 3101
%IDC_DelCatgs           = 3102

%IDC_BasicPrint         = 3201  'print entries
%IDC_ExpandedPrint      = 3202

%IDC_ArchStmts          = 3203

%Top = -5
%Bottom = 210
%NumDisplayed = 20

'--------------------------------------------------------------------------------
'   ** Types **
'--------------------------------------------------------------------------------
TYPE entryData       '22 total bytes
   date AS STRING*4  '20021231
   ckno AS STRING*4  '12345678
   amt AS LONG       '12.98 for pay, -12.98 for dep
   payee AS WORD     'index into payee()
   stmt AS WORD      'reconciled statement
   memo AS WORD      'index into memo()
   catg AS WORD      'category number
   acct AS BYTE      'account number
   flag AS BYTE
      'bit 0          cleared    ... cleared by bank
      'bit 1          monthly    ... monthly entry
      'bit 2          selected   ... marked for some purpose
      'bit 3          not used   ... 
      'bit 4          void       ... voided transaction
      'bit 5          deleted    ... deleted transaction
      'bit 6          transfer   ... transfer To/From another acct
      'bit 7          split      ... split transaction
END TYPE

TYPE acctData '30 bytes
   endBal AS QUAD        'ending balance for account
   beginDate AS LONG     'beginning date for account
   acctID AS STRING*20   'account number for info only
   lastCkNo AS LONG      'last check no
   unused AS INTEGER     'unused
END TYPE                 

TYPE stmtData '22 bytes
   openBal AS QUAD       'beginning balance of statement
   endBal AS QUAD        'closing balance of statement
   date AS LONG          'statement end date
   acct AS BYTE          'account number
   closed AS BYTE        'can be closed when reconcile diff = 0
END TYPE                 'open(0), closed(1), reopened(2)

TYPE catgData '5 bytes
   subcatg AS BYTE       'offset from parent catg, 0 for parent
   income AS BYTE        '1 for income, 0 for expense
   taxRef AS BYTE        'tax() index referencing tax [form,line] info
   budget AS INTEGER     'dollar amount monthly budget
END TYPE

TYPE splitData '6 bytes
   catg AS WORD          'category for item of split transaction
   amt AS LONG           'amount for item of split transaction
END TYPE


'--------------------------------------------------------------------------------
'   ** Globals **
'--------------------------------------------------------------------------------
GLOBAL ckBookID AS STRING *14
GLOBAL windowName AS ASCIIZ *32
GLOBAL hWindow AS LONG
GLOBAL hDlg AS DWORD
GLOBAL hMenu AS DWORD
GLOBAL hEditMenu AS DWORD
GLOBAL hStatus AS DWORD
GLOBAL hAcct AS LONG
GLOBAL hMouseMenu AS LONG
GLOBAL hDefCatg AS LONG
GLOBAL hCatg AS LONG
GLOBAL hSplit AS LONG
GLOBAL hdc AS LONG
GLOBAL hFont AS LONG
GLOBAL hOrigFont AS LONG
GLOBAL dlgHt AS LONG
GLOBAL dlgWidth AS LONG
GLOBAL numEntries AS WORD
GLOBAL numPayees AS WORD
GLOBAL numActive AS WORD
GLOBAL numAccts AS BYTE
GLOBAL numStmts AS INTEGER
GLOBAL numCatgs AS WORD
GLOBAL numSplits AS WORD
GLOBAL numSplitItems AS BYTE
GLOBAL numMemos AS WORD
GLOBAL numTaxes AS BYTE
GLOBAL numExpenses AS BYTE
GLOBAL entryNo AS WORD
GLOBAL acctNo AS BYTE
GLOBAL stmtNo AS WORD
GLOBAL lastAcct AS BYTE
GLOBAL NumDisplayed AS BYTE
GLOBAL vPos AS DOUBLE
GLOBAL regTop AS WORD
GLOBAL regBottom AS WORD
GLOBAL yBottom AS LONG
GLOBAL topEntry AS WORD
GLOBAL selector AS WORD
GLOBAL prevSelector AS WORD
GLOBAL editMode AS WORD
GLOBAL memdc AS LONG
GLOBAL dxpix AS LONG
GLOBAL dypix AS LONG
GLOBAL fontSize AS LONG
GLOBAL blankLen AS DOUBLE
GLOBAL gOldKbdProc AS DWORD
GLOBAL ghKbdHook AS LONG
GLOBAL backSpac AS BYTE
GLOBAL si AS SCROLLINFO
GLOBAL hScrollBar AS DWORD
GLOBAL lastDate AS STRING
GLOBAL nextField AS LONG
GLOBAL windowNo AS BYTE
GLOBAL fontType AS STRING
GLOBAL origDir AS STRING
GLOBAL thisFile AS STRING
GLOBAL catgFile AS STRING
GLOBAL fileChanged AS BYTE
GLOBAL selectAcctFcn AS BYTE
GLOBAL acctOpt AS BYTE
GLOBAL clear AS BYTE
GLOBAL back AS BYTE
GLOBAL enterFieldID AS LONG 
GLOBAL comboEdit AS BYTE
GLOBAL editAcct AS BYTE
GLOBAL editCatg AS BYTE
GLOBAL editItem AS BYTE
GLOBAL catgNo AS WORD
GLOBAL itemNo AS BYTE
GLOBAL dlgResult AS BYTE
GLOBAL showInit AS BYTE
GLOBAL splitOpt AS BYTE
GLOBAL splitAmt AS LONG
GLOBAL splitStr AS STRING
GLOBAL amtSelected AS QUAD
GLOBAL numSelected AS WORD
GLOBAL someDeleted AS BYTE
GLOBAL grpFound AS BYTE
GLOBAL viewStmtMode AS WORD
GLOBAL reconcileMode AS BYTE
GLOBAL archiveMode AS BYTE
GLOBAL archiveFile AS BYTE
GLOBAL reviveMonitor AS BYTE
GLOBAL grpChange AS BYTE
GLOBAL newStmt AS BYTE
GLOBAL editStmt AS BYTE
GLOBAL updatedAcct AS BYTE
GLOBAL noPaint AS BYTE
GLOBAL reconcileDiff AS QUAD
GLOBAL userPrompt AS BYTE
GLOBAL printing AS BYTE
GLOBAL moEntry AS BYTE
GLOBAL viewMoEntries AS BYTE
GLOBAL entry() AS entryData      'array of entries
GLOBAL acct() AS acctData        'array of accounts
GLOBAL stmt() AS stmtData        'array of statements
GLOBAL catg() AS catgData        'array of categories 
GLOBAL payee() AS STRING         'array of payees
GLOBAL memo() AS STRING          'array of memos
GLOBAL acctName() AS STRING      'array of account names
GLOBAL CatgName() AS STRING      'array of catg-subcatg names
GLOBAL split() AS STRING         'array of split transactions
GLOBAL tax() AS STRING           'array of tax [form,line] info
GLOBAL active() AS WORD          'array of active entries
GLOBAL qbal() AS QUAD            'array of active balances
GLOBAL vLine() AS LONG           'array of vert line coordinates
GLOBAL fields() AS STRING        'array of 8 fields
GLOBAL splitItem() AS splitData  'array of split transaction items
GLOBAL splitDescr() AS STRING    'array of split item descriptions 
GLOBAL moPayee() AS BYTE         'array of monthly payees

'--------------------------------------------------------------------------------
'   ** Declarations **
'--------------------------------------------------------------------------------
DECLARE CALLBACK FUNCTION PBMAINProc()
DECLARE CALLBACK FUNCTION selectAcctProc()
DECLARE CALLBACK FUNCTION createAcctProc()
DECLARE CALLBACK FUNCTION groupChgProc()
DECLARE CALLBACK FUNCTION processSplitProc()
DECLARE CALLBACK FUNCTION defineSplitItemProc()
DECLARE CALLBACK FUNCTION defineStmtProc()
DECLARE CALLBACK FUNCTION summaryProc()
DECLARE CALLBACK FUNCTION listStmtsProc()
DECLARE CALLBACK FUNCTION listCatgsProc()
DECLARE CALLBACK FUNCTION archiveStmtsProc()
DECLARE CALLBACK FUNCTION calendarProc()
DECLARE CALLBACK FUNCTION calculatorProc()
DECLARE CALLBACK FUNCTION findProc()
DECLARE CALLBACK FUNCTION aboutProc()
DECLARE FUNCTION EnumWindowsProc(BYVAL LONG, BYVAL LONG) AS LONG
DECLARE FUNCTION kbdProc&(BYVAL h&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&) AS LONG
DECLARE FUNCTION KeyboardHook(BYVAL INTEGER, BYVAL LONG, BYVAL LONG) AS DWORD
DECLARE FUNCTION MakeFont(LONG, STRING, BYVAL LONG, OPT BYVAL STRING) AS LONG
DECLARE FUNCTION leftAdj(LONG, STRING, LONG) AS LONG
DECLARE FUNCTION rightAdj(LONG, STRING, LONG) AS LONG
DECLARE FUNCTION getDate(LONG) AS STRING
DECLARE FUNCTION storDate(STRING) AS LONG
DECLARE FUNCTION numStr(DWORD) AS STRING
DECLARE FUNCTION numVal(STRING*4) AS DWORD
DECLARE FUNCTION clearedEntry() AS BYTE 
DECLARE FUNCTION getNumSubcatgs(LONG) AS LONG
DECLARE FUNCTION getCatg(LONG) AS STRING
DECLARE FUNCTION newCatg(STRING, STRING) AS WORD
DECLARE FUNCTION daysInMonth(LONG, LONG) AS LONG
DECLARE FUNCTION dayOfWeek(LONG, LONG, LONG) AS LONG
DECLARE FUNCTION validDate(STRING) AS LONG
DECLARE FUNCTION validMouseRegion(LONG, LONG) AS LONG
DECLARE FUNCTION openTheFile() AS LONG
DECLARE FUNCTION quitProgram() AS LONG
DECLARE SUB addMoEntries()
DECLARE SUB repaintScrn()
DECLARE SUB payeeSupplement()
DECLARE SUB AttachMenu()
DECLARE SUB AttachStatusBar()
DECLARE SUB statusLine(LONG)
DECLARE SUB toggleWindowState()
DECLARE SUB selectAcct(BYTE)
DECLARE SUB showText(LONG, LONG, LONG, STRING)
DECLARE SUB updateAcct()
DECLARE SUB updatePayees()
DECLARE SUB updateScrn()
DECLARE SUB clearEntry()
DECLARE SUB showLine(LONG, WORD, LONG)
DECLARE SUB addEntry()
DECLARE SUB showEntry()
DECLARE SUB truncateStr(LONG, STRING, LONG)
DECLARE SUB resetCatgList(LONG, LONG, LONG)
DECLARE SUB resetSubcatgList(LONG, LONG, LONG)
DECLARE SUB correctEntryCatgs(byval LONG, LONG)
DECLARE SUB resetTaxList()
DECLARE SUB setMenuState(OPT BYVAL LONG)
DECLARE SUB createAcct()
DECLARE SUB defineStmt()
DECLARE SUB defineCatg()
DECLARE SUB deleteCatg(WORD)
DECLARE SUB defineSplitItem()
DECLARE SUB processSplit()
DECLARE SUB getSplitItems()
DECLARE SUB setSplitItems()
DECLARE SUB disableEntryMode(LONG)
DECLARE SUB groupChg()
DECLARE SUB listAccts()
DECLARE SUB listStmts()
DECLARE SUB listCatgs()
DECLARE SUB listCatgItems()
DECLARE SUB listSplitItems()
DECLARE SUB openCatgFile()
DECLARE SUB openDialog()
DECLARE SUB openIniFile()
DECLARE SUB saveIniFile()
DECLARE SUB saveTheFile()
DECLARE SUB summary()
DECLARE SUB getFields(LONG)
DECLARE SUB archiveStmts()
DECLARE SUB recalcbalances()
DECLARE sub getReconcileDiff()
DECLARE SUB findRecord()
DECLARE SUB findPayee()
DECLARE SUB deleteSplit(WORD)
DECLARE SUB printData()
DECLARE SUB about()

'--------------------------------------------------------------------------------
'   ** Notes **
'--------------------------------------------------------------------------------
'save as follows
'   numEntries
'   numPayees
'   numAccts
'   numStmts
'   numCatgs
'   numSplits
'   numMemos
'   numTaxes

'   for i = 1 to numEntries
'      entry(i)
'   next i

'   for i = 1 to numPayees
'      numBytes, payee(i) AS STRING
'   next i

'   for i = 1 to numAccts
'      accts(i)
'      numBytes, acctName(i)
'   next i

'   for i = 1 to numStmts
'      stmts(i)
'   next i

'   for i = 1 to numCatgs
'      catg(i) AS catgData
'      numBytes, catgName() AS STRING
'   next i

'   for i = 1 to numSplits
'      numBytes, split(i) AS STRING
'   next i

'   for i = 1 to numMemos
'      numBytes, memo(i) AS STRING
'   next i

'   for i = 1 to numTaxes
'      numBytes, tax(i) AS STRING
'   next i

'------------------------------------------------------------------------
'maximum of 65536 entries
'maximum of 65536 payees
'maximum of 255 accounts
'maximum of 65536 statements
'maximum of 65536 memos
'maximum of 65536 categories
'maximum of 255 taxes

'archive by statements - statements deleted from checkbook
'cannot change or delete reconciled entry
'array active() used to show valid entries of displayed account

'---------------------------------------------------------------------------
'entry().catg
'   with transfer flag set = To/From acct No.
'   with split flag set    = split() index
'   else                   = category - subcategory
'
'   split() AS STRING...
'   numItems as byte,[catg as WORD, amt AS LONG, descrBytes, descr], [....],...

'---------------------------------------------------------------------------
'to start an existing acct:
'specify ending balance of last bank statement(06-30-02), say $1250.00
'program automatically assigns next acctNo... say 4, if 3 already exist
'program automatically assigns next stmtNo... say 132, if 131 already exist
'statements are ordered by date... stmt().date
'--------------------------------
'acct(4).endBal = 125000
'acct(4).beginDate = 20020630
'acct(4).lastStmtNo = 131
'--------------------------------
'stmt(132).endBal = 125000
'stmt(132).prevStmtNo = 0
'stmt(132).stmtDate = 20020630
'stmt(132).acctNo = 4
'-------------------------------- 
'---------------------------------------------------------------------------
'delete, void, or move entry:
'- cannot be a reconciled entry

'---------------------------------------------------------------------------
'change entry:
'- amounts cannot be changed for reconciled entries
'- otherwise, any entry can be changed

'---------------------------------------------------------------------------
'group edits:
'- specify fields which are to be common changes for group
'  ... check boxes to remove memo or catg
'  ... cannot specify an amount when a selected entry is reconciled
'- select entries making up the group
'- click [Group edit] from Edit menu

'---------------------------------------------------------------------------
'Acct balances:
'- new entry is added to register
'  endBal = endBal - entry.amt
'- when entry is cleared (pressing C) in an earlier stmt than acct beginDate
'  endBal = endBal + entry.amt
'  (so that there is no net change on end balance)
'---------------------------------------------------------------------------
'Archiving:
'- include only payees used in archive file
'- keep all payees used in original file for remaining file 
'  (this will eliminate payees not used since last archive)
'- include only statements used in archive file
'- keep only statements used in remaining file
'- do not display balances in archive file
'- archive file cannot be changed, only scanned

'---------------------------------------------------------------------------
'Categories.ini
'Catg1
'  - SubCatg1  [Tax D,12]  [Budget 40.00]  
'  - SubCatg2  [Tax A,16]
'  - SubCatg3
'Catg2
'  - SubCatg1              [Budget 25.00]
'  - SubCatg2
'etc ...
'---------------------------------------------------------------------------

'---------------------------------------------------------------------------
'acctOpt = 0  select account only
'        = 1  create, edit, delete, or select
'        = 2  opening program - create or open acct
'             (if no accts exist then open --> opens file dialog)
'        = 3  acct just opened, status of stmts undetermined       
'---------------------------------------------------------------------------

'splitOpt = 0  view splits only
'         = 1  add or edit splits
'         = 2  changed splits
